<?php 
    if(isset($_POST['nonce'])){
        $verify_nonce = wp_verify_nonce( $_POST['nonce'], 'elementor_forms-amocrm');
    }
    
    // удаляем кастомную форму
    if( isset($_POST['action']) and $_POST['action'] === 'delete_form' and isset($_POST['nonce']) and $verify_nonce ){
        wp_delete_post($_POST['elementor_forms_id'], true);
    }

    // удаляем лид
    if( isset($_GET['action']) and $_GET['action'] === 'delete_lead' and isset($_GET['lead_id']) and wp_verify_nonce( $_GET['nonce'], 'elementor_forms-amocrm') ){
        wp_delete_post($_GET['lead_id'], true);
    }

    // сохраняем настройки кастомной формы
    if( isset($_POST['action']) and $_POST['action'] === 'save_elementor_forms' and isset($_POST['nonce']) and $verify_nonce ){
        $_POST['elementor_forms-amocrm']['tags'] = isset($_POST['elementor_forms-amocrm']['tags']) ? $_POST['elementor_forms-amocrm']['tags'] : [];
        wp_update_post(wp_slash([
            'ID' => $_POST['elementor_forms_id'],
            'post_title' => $_POST['post_title'],
        ]));
        update_post_meta( $_POST['elementor_forms_id'], 'elementor_forms-amocrm', ($_POST['elementor_forms-amocrm']) );
    }
       
    // сохранем общие настройки плагина
    if( isset($_POST['action']) and $_POST['action'] === 'save_settings' and isset($_POST['nonce']) and $verify_nonce ){
        update_option( 'elementor_forms-amocrm', $_POST['elementor_forms-amocrm'], 'no' );
    }

    // обновляем данные из amoCRM
    if( isset($_GET['clear']) and $_GET['clear'] ){
        getAmoFields_forms_amocrm();
    }

    require_once (__DIR__ . '/fields_default.php');

    $settings = get_option('elementor_forms-amocrm');
    if(!isset($settings['time_zone']) ){
        $settings['time_zone'] = 'Europe/Moscow';
    }

    $amo_settings = get_option('elementor_forms-amocrm-settings');
    if( !$amo_settings ){
        $amo_settings = getAmoFields_forms_amocrm();
    }

    $amoFields = isset($amo_settings['fields']) ? $amo_settings['fields'] : ['0' => __( 'Fields not loaded', 'elementor_forms-amocrm' )];
    $amoManagers = isset($amo_settings['managers']) ? $amo_settings['managers'] : ['0' => __( 'Managers not loaded', 'elementor_forms-amocrm' )];

    if(isset($_GET['elementor_forms_id']) and $_GET['elementor_forms_id']){
        $form = get_post($_GET['elementor_forms_id'], 'ARRAY_A');
        $get_post_meta = get_post_meta( $_GET['elementor_forms_id'], 'elementor_forms-amocrm', 1 );
        $antidub_fields = isset($amo_settings['antidub_fields']) ? $amo_settings['antidub_fields'] : [0 => 'Не загружено'];
        $fields = $get_post_meta ? ($get_post_meta) : [];
        $post_tags = (isset($fields['post_ID']) and $fields['post_ID'] !== '0') ? $custom_tags : $custom_tags_short;
        $all_tags = array_keys( $post_tags );
        $all_tags[] = 'order_id';
        $form_tags = getFormKeys($_GET['elementor_forms_id']);

        if($form_tags){
            foreach($form_tags as $form_field){
                $all_tags[] = $form_field;
            }
        }
        $form_fields_value = getFormFieldValues($_GET['elementor_forms_id']);
        $amoPipelines = isset($amo_settings['pipelines']) ? $amo_settings['pipelines'] : ['0' => ['name' => __( 'Pipelines not loaded', 'elementor_forms-amocrm' )]];
        $fields['task'] = isset($fields['status']) ? $fields['task'] : $task_default;
        $task_types = $amo_settings['task_types'];
        $note = isset($fields['note']) ? $fields['note'] : $note_default;
        $fields['status'] = isset($fields['status']) ? $fields['status'] : true;
        $fields['lead_name'] = isset($fields['lead_name']) ? $fields['lead_name'] : $lead_name_default;
        $fields['price'] = isset($fields['price']) ? $fields['price'] : 1000;
        $fields['pipeline_id'] = (!isset($fields['pipeline_id']) and $amoPipelines ) ? key($amoPipelines) : $fields['pipeline_id']; 
        $fields['responsible_list'] = !isset($fields['responsible_list'])  ? [] : $fields['responsible_list'];
        $fields['distribution'] = isset($fields['distribution']) ? $fields['distribution'] : 0;
        $fields['tags'] = isset($fields['tags']) ? $fields['tags'] : $tags_default;
        $change_responsible = isset($fields['antidub']['change_responsible']) ? $fields['antidub']['change_responsible'] : 0;
        $ignore = isset($fields['antidub']['ignore']) ? $fields['antidub']['ignore'] : [];
        $fields['antidub']['status'] = isset($fields['antidub']['status']) ? $fields['antidub']['status'] : 0;
        $notify = isset($fields['notify']) ? $fields['notify'] : ['vk' => ['status' => 0]];

        $fields['antidub_lead']['status'] = isset($fields['antidub_lead']['status']) ? $fields['antidub_lead']['status'] : 0;
        $fields['antidub_lead']['update_lead'] = isset($fields['antidub_lead']['update_lead']) ? $fields['antidub_lead']['update_lead'] : 0;
        $fields['antidub_lead']['tags'] = isset($fields['antidub_lead']['tags']) ? $fields['antidub_lead']['tags'] : 'Дубль';
        $fields['antidub_lead']['note'] = isset($fields['antidub_lead']['note']) ? $fields['antidub_lead']['note'] : 'Сработал антидубль сделок';

        $required = isset($fields['required']) ? $fields['required'] : [];
        $is_new_form = isset($fields['required']) ? 0 : 1;
        require_once (__DIR__ . '/elementor_form_view.php');
    }elseif( isset($_GET['lead_id']) and $_GET['lead_id'] ){
        $form = get_post($_GET['lead_id'], 'ARRAY_A');
        require_once (__DIR__ . '/lead_view.php');
    }elseif( isset($_GET['testing']) ){
        $testing = testing_forms_amocrm();
        $current_version = get_plugin_data(__DIR__ . '/elementor_forms-amocrm.php')['Version'];
        $version = ( isset($testing['version']) ) ? $testing['version'] : __( 'unknown', 'elementor_forms-amocrm' );
        $auth = (isset($testing['auth']) and $testing['auth']) ? __( 'active', 'elementor_forms-amocrm' ) : __( 'authorization required! Click the "Authorization in amoCRM" button', 'elementor_forms-amocrm' );
        $subscribe = isset($testing['subscribe']) ? __( 'until ', 'elementor_forms-amocrm' ) . date('d.m.Y', $testing['subscribe'] ) : __( 'expired', 'elementor_forms-amocrm' );
        $curl = function_exists('curl_version') ? __( 'installed', 'elementor_forms-amocrm' ) : __( 'not installed', 'elementor_forms-amocrm' );
        require_once (__DIR__ . '/testing.php');
    }elseif( isset($_GET['logs']) ){
        $log = file_get_contents('https://devamo.ru/logs?widget=elementor&url='.$_SERVER['SERVER_NAME']);
        require_once (__DIR__ . '/logs.php');
    }else{
        $forms_custom = get_elementor_formss_amocrm();
        $leads = getLeads_forms_amocrm();
        $settings['urls_disabled'] = isset($settings['urls_disabled']) ? $settings['urls_disabled'] : '';
        require_once (__DIR__ . '/settings_page.php');
    }
?>
