<?php 

function elementorFormsComplete_amocrm( $form_id, $post ) {   
    $form_fields = get_post_meta( $form_id, 'elementor_forms-amocrm', 1 );
    if( isset($form_fields['status']) and $form_fields['status'] ){
        $settings = get_option('elementor_forms-amocrm');
        if(!isset($settings['time_zone']) ){
            $settings['time_zone'] = 'Europe/Moscow';
        }
        date_default_timezone_set($settings['time_zone']);
        $options = get_option('elementor_forms-amocrm-settings');
        $field_types = $options['field_types'];
        $utms = isset($options['utm_fields']) ? $options['utm_fields'] : false;
        $responsible_user_id = responsible_user_id_elementor_amocrm($form_id);
        $lead_name = $form_fields['lead_name'];
        $note = $form_fields['note'];
        $task_text = $form_fields['task']['task_text'];

        $post_id = $post['post_ID'];
        $page_name = get_the_title($post_id);
        $page_url = get_option('home').'?p='.$post_id;

        $required = isset($form_fields['required']) ? $form_fields['required'] : [];       

        // проверим на заполнение обязательные поля
        if($required){
            foreach($required as $key => $req){
                if( !isset($post[$req]) or $post[$req] !== '' ){
                    unset($required[$key]);
                }
            }
        }

        $form_name = get_the_title($form_id);
        $home_url = get_option('home');
        $date = date('d.m.Y');
        $time = date('H:i:s');   
        require (__DIR__ . '/fields_default.php');

        $ip = getIp_forms_amocrm();
        $userAgent = $_SERVER['HTTP_USER_AGENT'];
        $os = getOS_forms_amocrm($userAgent);
        $browser = getBrowser_forms_amocrm($userAgent);   
        
        foreach($custom_tags as $custom_tag => $custom_tag_name){

            if(isset(${$custom_tag})){
                $lead_name = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $lead_name);
                $note = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $note);
            }

            $custom_tag_value = $form_fields['custom_tags'][$custom_tag]; // !!!!!!!!!
            if($custom_tag_value !== '0' and $custom_tag_value !== ''){
                $_data = explode('-', $custom_tag_value);
                $entry = $_data['0'];
                $field_id = $_data['1'];
                $field_type = 'text';
                if(isset($field_types[$entry][$field_id])){
                    $field_type = $field_types[$entry][$field_id];
                }
    
                if( in_array($field_type, ['date_time', 'birthday', 'date']) ){
                    $form_value = strtotime(${$custom_tag});
                }elseif( in_array($field_type, ['checkbox']) ){
                    $form_value = ${$custom_tag} ? true : false;
                }else{
                    $form_value = (string)${$custom_tag};
                }
    
                if($form_value === '' or $form_value === null){
                    continue;
                }
                
                if($field_id === 'price'){
                    $form_value = (int)$form_value;
                }
    
                if( in_array($field_id, ['price', 'name', 'first_name', 'last_name']) ){
                    ${$entry}[$field_id] = $form_value;
                }else{
    
                    if(is_array(${$custom_tag})){
                        $values = [];
                        foreach(${$custom_tag} as $fv){
                            $values[] = ['value' => $fv];
                        }
                        ${$entry}['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => $values
                        ];
                    }else{
                        ${$entry}['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => [
                                [
                                    'value' => $form_value
                                ]
                            ]
                        ];
                    }
                }
            }
        }
        
        foreach($post as $form_field => $form_field_value){
            $key = isset($form_fields['fields'][$form_field]) ? $form_fields['fields'][$form_field] : false;
           
            if($key !== '0' and $key !== ''){
                $_data = explode('-', $key);
                $entry = $_data['0'];
                $field_id = $_data['1'];
    
                $field_type = 'text';
    
                if(isset($field_types[$entry][$field_id])){
                    $field_type = $field_types[$entry][$field_id];
                }
    
                if( in_array($field_type, ['date_time', 'birthday', 'date']) ){
                    $form_value = strtotime($form_field_value);
                }elseif( in_array($field_type, ['checkbox']) ){
                    $form_value = $form_field_value ? true : false;
                }else{
                    $form_value = (string)$form_field_value;
                }
    
                if($form_value === '' or $form_value === null){
                    continue;
                }

                if($field_id === 'price'){
                    $form_value = (int)$form_value;
                }
    
                if( in_array($field_id, ['price', 'name', 'first_name', 'last_name']) ){
                    ${$entry}[$field_id] = $form_value;
                }else{
                    if( in_array($field_type, ['checkbox']) ){
                        ${$entry}['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => [
                                [
                                    'value' => $form_value
                                ]
                            ]
                        ];
                    }elseif(is_array($form_field_value)){
                        $values = [];
                        foreach($form_field_value as $fv){
                            $values[] = ['value' => $fv];
                        }
                        ${$entry}['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => $values
                        ];
                    }else{
                        ${$entry}['custom_fields_values'][] = [
                            'field_id' => (int)$field_id,
                            'values' => [
                                [
                                    'value' => $form_value
                                ]
                            ]
                        ];
                    }
                }
            }

            $note = str_replace('{{'.$form_field.'}}', $form_field_value, $note);
            $lead_name = str_replace('{{'.$form_field.'}}', $form_field_value, $lead_name);     
            $task_text = str_replace('{{'.$form_field.'}}', $form_field_value, $task_text);   
        }
    
        if($utms){
            foreach($utms as $field_id => $utm){
                if (isset($_COOKIE[$utm])) {
                    $lead['custom_fields_values'][] = [
                        'field_id' => (int)$field_id,
                        'values' => [
                            [
                                'value' => (string)$_COOKIE[$utm]
                            ]
                        ]
                    ];
                }
            }
        }

        $task = [];
        if( $form_fields['task']['task_status'] == 1 ){
            $task_type = $form_fields['task']['task_type'];
            
            foreach($custom_tags as $custom_tag => $custom_tag_name){

                if(isset(${$custom_tag})){
                    $task_text = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $task_text);
                }

                
            }

            $task_complete_till = $form_fields['task']['task_complete_till'];
            $task_complete_till_times = $form_fields['task']['task_complete_till_times'];
            $current_datetime = date('Y-m-d H:i:s');
            $task_complete_till = strtotime($current_datetime . ' +' . $task_complete_till . ' ' . $task_complete_till_times );
            $task = [
                'task_type_id' => (int)$task_type,
                'text' => $task_text,
                'complete_till' => (int)$task_complete_till
            ];

            if($responsible_user_id){
                $task['responsible_user_id'] = $responsible_user_id;
            }
        }

        $pipeline_id = (int)$form_fields['pipeline_id'];
        $p_status = (int)$form_fields['p_status'];
        $price = (int)$form_fields['price'];

        if($lead_name){
            $lead['name'] = $lead_name;
        }
   
        if($pipeline_id){
            $lead['pipeline_id'] = $pipeline_id;
        }
    
        if($p_status){
            $lead['status_id'] = $p_status;
        }
    
        if($responsible_user_id){
            $lead['responsible_user_id'] = $responsible_user_id;
        }

        if($price){
            $lead['price'] = $price;
        }           

        if($form_fields['tags']){
            foreach($form_fields['tags'] as $tag){
                if(empty($tag)){
                    continue;
                }
                foreach($custom_tags as $custom_tag => $custom_tag_name){
                    if(isset(${$custom_tag})){
                        $tag = str_replace('{{'.$custom_tag.'}}', ${$custom_tag}, $tag);
                    }
                }
                $lead['_embedded']['tags'][] = ['name' => $tag];
            }
        }

        if(isset($contact) and $responsible_user_id){
            $contact['responsible_user_id'] = $responsible_user_id;
        }

        $note = strip_tags($note);
        
        $entryes = [
            'lead' => isset($lead) ? $lead : [],
            'contact' => isset($contact) ? $contact : [],
            'note' => isset($note) ? $note : [],
            'task' => isset($task) ? $task : [],
            'ip' => $ip,
            'antidub' => $form_fields['antidub'],
            'antidub_lead' => $form_fields['antidub_lead']
        ];


        if($required){
            return $required;
        }

        $unsortered = strpos($form_fields['p_status'], 'unsortered_');

        // если неразобранное
        if($unsortered !== false){
            $entryes['source_name'] = get_option('blogname');
            $entryes['source_uid'] = md5(microtime(true).'devamo.ru');
            if($pipeline_id){
                $entryes['pipeline_id'] = $pipeline_id;
            }
            
        }else{
            // если разобранное
            $entryes['lead']['status_id'] = (int)$p_status;
            $entryes['lead']['pipeline_id'] = $pipeline_id;
        }

        if($unsortered !== false){
            //$entryes['request_id'] = (string)$save_post_id;

            if(isset($entryes['lead'])){
                $entryes['_embedded']['leads'][] = $entryes['lead'];
                unset($entryes['lead']);
            }

            if(isset($entryes['contact'])){
                $entryes['_embedded']['contacts'][] = $entryes['contact'];
                unset($entryes['contact']);
            }

            if(isset($entryes['company'])){
                $entryes['_embedded']['companies'][] = $entryes['company'];
                unset($entryes['company']);
            }

            $entryes['metadata'] = [
                'ip' => $ip,
                'form_id' => $form_id,
                'form_sent_at' => (int)time(),
                'form_name' => $form_name,
                'form_page' => $_SERVER['SERVER_NAME'],
            ];

            unset($entryes['note']);
            unset($entryes['antidub']);
            unset($entryes['antidub_lead']);
            unset($entryes['task']);
            unset($entryes['salesbot']);
            unset($entryes['notify']);
            unset($entryes['ip']);

            $data['action'] = 'unsortered';
        }else{
            $data['action'] = 'CF7V2';
        }

        $data['data'] = json_encode($entryes);
        $data['url'] = $_SERVER['SERVER_NAME'];
        
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_URL, 'https://devamo.ru/elementor/ajax');
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
        curl_exec($curl);

        new_forms_amocrm_lead($form_id, $entryes, true);
        return $required;
    }
    return true;
}

function getIp_forms_amocrm(){
    $client  = isset($_SERVER['HTTP_CLIENT_IP']) ? $_SERVER['HTTP_CLIENT_IP'] : false;
    $forward = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : false;
    $remote  = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : $_SERVER['REMOTE_ADDR'];
    if(filter_var($client, FILTER_VALIDATE_IP)){
        $ip = $client;
    }elseif(filter_var($forward, FILTER_VALIDATE_IP)){
        $ip = $forward;
    }else{
        $ip = $remote;
    }
    return $ip;
}

function getOS_forms_amocrm($userAgent) { 
    $os_platform  = "Unknown OS Platform";
    $os_array     =  [
        '/windows nt 10/i'      =>  'Windows 10',
        '/windows nt 6.3/i'     =>  'Windows 8.1',
        '/windows nt 6.2/i'     =>  'Windows 8',
        '/windows nt 6.1/i'     =>  'Windows 7',
        '/windows nt 6.0/i'     =>  'Windows Vista',
        '/windows nt 5.2/i'     =>  'Windows Server 2003/XP x64',
        '/windows nt 5.1/i'     =>  'Windows XP',
        '/windows xp/i'         =>  'Windows XP',
        '/windows nt 5.0/i'     =>  'Windows 2000',
        '/windows me/i'         =>  'Windows ME',
        '/win98/i'              =>  'Windows 98',
        '/win95/i'              =>  'Windows 95',
        '/win16/i'              =>  'Windows 3.11',
        '/macintosh|mac os x/i' =>  'Mac OS X',
        '/mac_powerpc/i'        =>  'Mac OS 9',
        '/linux/i'              =>  'Linux',
        '/ubuntu/i'             =>  'Ubuntu',
        '/iphone/i'             =>  'iPhone',
        '/ipod/i'               =>  'iPod',
        '/ipad/i'               =>  'iPad',
        '/android/i'            =>  'Android',
        '/blackberry/i'         =>  'BlackBerry',
        '/webos/i'              =>  'Mobile'
    ];
    foreach ($os_array as $regex => $value){
        if (preg_match($regex, $userAgent)){
            $os_platform = $value;
        }
    }
    return $os_platform;
}

function getBrowser_forms_amocrm($userAgent) {
      $browsers = [
        'Firefox',
        'Opera',
        'Chrome',
        'MSIE',
        'Safari'
      ];
      foreach($browsers as $browser){
          if(strpos($userAgent, $browser) !== false) { 
              return $browser;
          }
      }
      return 'Неизвестный'; // Хрен его знает, чего у него на десктопе стоит.
  }

// сохраняет отправленные заявки
function new_forms_amocrm_lead($form_id, $data){
    $form = get_post($form_id, 'ARRAY_A');
    $comment_count = $form['comment_count'];
    $comment_count++;
    $amo_settings = get_option('elementor_forms-amocrm-settings');
    $text = [];
    foreach($data as $entry => $entry_value){
    
        $entry_keys = is_array($entry_value) ? array_keys($entry_value) : false;
        if($entry_keys){
            foreach($entry_keys as $entry_key){

                $value = $entry_value[$entry_key];
                $pipeline_id = isset($data[$entry]['pipeline_id']) ? $data[$entry]['pipeline_id'] : false;

                if( in_array($entry, ['lead', 'contact']) ){
                    switch ($entry_key) {
                        case 'name':
                            if($entry === 'lead'){
                                $name = __( 'Lead name', 'elementor_forms-amocrm' );
                            }elseif($entry === 'contact'){
                                $name = __( 'Contact name', 'elementor_forms-amocrm' );
                            }
                            $text[$entry][0] = $name.': '.$value;
                            break;
                        case 'responsible_user_id':
                            $text[$entry][3] = __( 'Responsible', 'elementor_forms-amocrm' ).': '.$amo_settings['managers'][$value];
                            break;
                        case 'pipeline_id':
                            $text[$entry][1] = __( 'Pipeline', 'elementor_forms-amocrm' ).': '.$amo_settings['pipelines'][$pipeline_id]['name'];
                            break;
                        case 'status_id':
                            $text[$entry][2] = __( 'Pipeline status', 'elementor_forms-amocrm' ).': '.$amo_settings['pipelines'][$pipeline_id]['statuses'][$value]['name'];
                            break;
                        case 'price':
                            $text[$entry][4] = __( 'Price', 'elementor_forms-amocrm' ).': '.$value;
                            break;
                        case 'first_name':
                            $text[$entry][0] = __( 'First name', 'elementor_forms-amocrm' ).': '.$value;
                            break;
                        case 'last_name':
                            $text[$entry][1] = __( 'Last name', 'elementor_forms-amocrm' ).': '.$value;
                            break;
                        case '_embedded':
                            if(isset($data['lead']['_embedded'])){
                                $tags = [];
                                foreach($data['lead']['_embedded']['tags'] as $tag){
                                    $tags[] = $tag['name'];
                                }
                                $text[$entry][99] = 'Теги: '.implode(', ', $tags);
                            }
                            break;
                        case 'custom_fields_values':
                            $fields = isset($data[$entry]['custom_fields_values']) ? $data['lead']['custom_fields_values'] : false;
                            if($fields){
                                $i = 10;
                                foreach($fields as $field){
                                    $field_name = false;
                                    $i++;
                                    if(isset($amo_settings['fields'][$entry.'-'.$field['field_id']])){
                                        $field_name = $amo_settings['fields'][$entry.'-'.$field['field_id']];
                                        $field_name =  str_replace(['Контакт :: ', 'Сделка :: '], '', $field_name);
                                        if($field['values']){
                                            $field_values = [];
                                            foreach($field['values'] as $field_value){
                                                $field_values[] = $field_value['value'];
                                            }
                                            $text[$entry][$i] = $field_name.': '.implode(', ', $field_values);
                                        }
                                    }
        
                                    if(isset($amo_settings['utm_fields'][$field['field_id']])){
                                        $field_name = $amo_settings['utm_fields'][$field['field_id']];
                                        if($field['values']){
                                            $field_values = [];
                                            foreach($field['values'] as $field_value){
                                                $field_values[] = $field_value['value'];
                                            }
                                            $text[$entry][$i] = $field_name.': '.implode(', ', $field_values);
                                        }
                                    }
        
                                }
                            }
                            break;
                    }
                    }
                    
                    if($entry === 'task'){
                        $task = $data['task'];
                        switch ($entry_key) {
                            case 'responsible_user_id':
                                if( isset($amo_settings['managers'][$task['responsible_user_id']]) ){
                                    $text[$entry][3] = __( 'Responsible', 'elementor_forms-amocrm' ).': '.$amo_settings['managers'][$task['responsible_user_id']];
                                }
                                break;
                            case 'text':
                                $text[$entry][0] = __( 'Descriptio', 'elementor_forms-amocrm' ).': '.$task['text'];
                                break;
                            case 'complete_till':
                                $text[$entry][1] = __( 'Deadline', 'elementor_forms-amocrm' ).': '.date('d.m.Y H:i:s', $task['complete_till']);
                                break;
                            case 'task_type_id':
                                $task_type_name = '';
                                foreach($amo_settings['task_types'] as $task_type){
                                    if($task['task_type_id'] == $task_type['id']){
                                        $text[$entry][2] = __( 'Type', 'elementor_forms-amocrm' ).': '.$task_type['name'];
                                    }
                                }
                                break;
                        }
                    }
                }
        }

        if($entry === 'note'){
            $text[$entry] = $entry_value;
        }           
        
    }

    $print = '';

    if(isset($text['lead'])){
        ksort($text['lead']);
        $print .= '<div>';
        $print .= '<div><b>'.__( 'Lead', 'elementor_forms-amocrm' ).'</b></div>';
        $print .= '<p>'.implode('</p><p>', $text['lead']).'</p>';
        $print .= '</div><br>';
    }

    if(isset($text['note'])){
        $print .= '<div>';
        $print .= '<div><b>'.__( 'Note', 'elementor_forms-amocrm' ).'</b></div>';
        $print .= '<p>' . str_replace(PHP_EOL, '</p><p>', $text['note']) . '</p>';
        $print .= '</div><br>';
    }

    if(isset($text['contact'])){
        ksort($text['contact']);
        $print .= '<div>';
        $print .= '<div><b>'.__( 'Contact', 'elementor_forms-amocrm' ).'</b></div>';
        $print .= '<p>'.implode('</p><p>', $text['contact']).'</p>';
        $print .= '</div><br>';
    }

    if(isset($text['task'])){
        ksort($text['task']);
        $print .= '<div>';
        $print .= '<div><b>'.__( 'Task', 'elementor_forms-amocrm' ).'</b></div>';
        $print .= '<p>'.implode('</p><p>', $text['task']).'</p>';
        $print .= '</div>';
    }
    
    wp_insert_post(wp_slash([
        'post_title'    => date('d.m.Y H:i:s'),
        'post_parent'   => $form_id,
        'post_content'  => $print,
        'post_status'   => 'publish',
        'post_type'     => 'elementor-lead',
        'post_excerpt' => serialize($data)
    ]));
    
}

function getLeads_forms_amocrm(){
    global $wpdb;
    $forms = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE post_type = 'elementor-lead' AND post_status = 'publish' ORDER BY ID DESC", 'ARRAY_A' );
    if($forms){
        foreach ( $forms as $key => $form ) {
            $forms[$key]['post_date'] = date('d.m.Y H:i', strtotime($form['post_date']));
        }
    }
    return $forms;
}

function getLeadsByForm_forms_amocrm($form_id){
    global $wpdb;
    return $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts WHERE post_type = 'elementor-lead' AND post_status = 'publish' AND post_parent = '".$form_id."'" );
}

function get_elementor_formss_amocrm(){
    global $wpdb;
    $forms = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE post_type = 'elementor-amocrm' AND post_status = 'publish' ORDER BY ID DESC", 'ARRAY_A' );
    if($forms){
        foreach ( $forms as $key => $form ) {
            $forms[$key]['post_date'] = date('d.m.Y H:i', strtotime($form['post_date']));
        }
    }
    return $forms;
}

// возвращает ключи формы
function getFormKeys($form_id){
    $form = get_post($form_id, 'ARRAY_A');
    return $form ? explode(',', $form['post_excerpt']) : [];    
}

// возвращает значения формы
function getFormFieldValues($form_id){
    $form = get_post($form_id, 'ARRAY_A');
    return $form ? unserialize($form['post_content']) : [];    
}

// ищет форму по ключам
function findElementorForm_amocrm($keys = ''){
    global $wpdb;
    $form = $wpdb->get_row( "SELECT * FROM $wpdb->posts WHERE post_type = 'elementor-amocrm' AND post_status = 'publish' AND post_excerpt = '".$keys."'", 'ARRAY_A' );
    if($form){
        $form['post_date'] = date('d.m.Y H:i', strtotime($form['post_date']));
    }
    return $form;
}

function getAmoFields_forms_amocrm(){
    $data = ['action' => 'getAmoCF', 'url' => $_SERVER['SERVER_NAME'], 'companies' => true];
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_URL, 'https://devamo.ru/elementor/ajax');
    curl_setopt($curl, CURLOPT_HEADER, false);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
    $output = curl_exec($curl);
    curl_close($curl);
    $output = json_decode($output, true);
	if(isset($output['status']) and $output['status']){
        update_option( 'elementor_forms-amocrm-settings', $output['settings'] );
	}
	return isset($output['settings']) ? $output['settings'] : false;
}

function elementorforms_amocrm_admin() {
	add_options_page('Elementor amoCRM', 'Elementor amoCRM', 'manage_options', 'elementor_forms-amocrm', 'forms_amocrm_settings_page');
}
function forms_amocrm_settings_page(){
	require_once (__DIR__ . '/admin.php');;
}

function elementorforms_amocrm_save_utm_to_cookie() {
    $date = time()+3600*24*30;
    $options = get_option('elementor_forms-amocrm-settings');
    $utms = isset($options['utm_fields']) ? $options['utm_fields'] : false;
    if($utms){
        foreach($utms as $utm){
            if(isset($_GET[$utm])) setcookie($utm, $_GET[$utm], $date, "/"); 
        }
    }
}

function elementorforms_amocrm_deactivate(){
    delete_option('elementor_forms-amocrm');
    delete_option('elementor_forms-amocrm-settings');
}

function elementorforms_amocrm_activate(){
    if( !getAmoFields_forms_amocrm() ){
        exit('Website '.$_SERVER['SERVER_NAME'].__( ' not added in amoCRM widget settings! <br>Go to amoCRM, select amoMarket from the menu on the left > Installed, then find "Contact Form 7 wordpress" and click on it, in the pop-up window add your site to the corresponding field.<br>Technical support amo@devamo.ru or telegram @bmite', 'elementor_forms-amocrm' ) );
    }
}

add_filter('plugin_action_links', 'forms_amocrm_links', 10, 2);
function forms_amocrm_links($actions, $plugin_file ) {
	if( false === strpos( $plugin_file, 'elementor_forms-amocrm' ) ){
        return $actions;
    }
	$settings_link = '<a href="/wp-admin/options-general.php?page=elementor_forms-amocrm' .'">'.__( 'Settings', 'elementor_forms-amocrm' ).'</a>'; 
	array_unshift( $actions, $settings_link ); 
	return $actions; 
}

function elementorforms_amocrm_scripts( $hook_suffix ) {
	if ( false === strpos( $hook_suffix, 'elementor_forms-amocrm' ) ) {
		return;
	}
	wp_enqueue_script('elementor_forms-amocrm', plugins_url( 'elementor_forms-amocrm/js/main.js' ), '', filemtime( __DIR__ . ('/js/main.js') ) ,true);
    wp_enqueue_script('elementor_forms_amocrm_chosen', plugins_url( 'elementor_forms-amocrm/js/chosen.jquery.min.js' ), '', filemtime( __DIR__ . ('/js/chosen.jquery.min.js') ) ,true);
    wp_enqueue_style( 'elementor_forms_amocrm_chosen', plugins_url( 'elementor_forms-amocrm/css/chosen.min.css' ), null, filemtime( __DIR__ . ('/css/chosen.min.css') ), 'all' );
    wp_enqueue_style( 'elementor_forms-amocrm', plugins_url( 'elementor_forms-amocrm/css/main.css' ), null, filemtime( __DIR__ . ('/css/main.css') ), 'all' );

}

function newForm_forms_amocrm(){
    $post = $_POST;
    if(!$post){
        echo json_encode(['status' => 0, 'message' => 'Нет данных']);
        wp_die();
    }
    $post_tmp = $post;

    $keys = implode(',', array_keys($post_tmp));
    $form = findElementorForm_amocrm($keys);
    
    if($form){
        wp_update_post(wp_slash([
            'ID' => $form['ID'],
            'post_content' => serialize($post_tmp),
            'post_excerpt' => $keys,
        ]));
        
        $required = elementorFormsComplete_amocrm($form['ID'], $post);
        if( $required ){
            echo json_encode(['status' => 0, 'message' => 'Не заполнены обязательные поля: '.implode(', ', $required)]);
        }        
    }else{
        $post_id = wp_insert_post(wp_slash([
            'post_title'    => 'Новая форма '.date('d.m.Y H:i:s'),
            'post_content'  => serialize($post),
            'post_status'   => 'publish',
            'post_type'     => 'elementor-amocrm',
            'post_excerpt'  => $keys,
        ]), true);
    echo json_encode(['status' => 1, 'message' => 'Форма создана', 'post_id' => $post_id, /*'errors' => $post_id->get_error_message()*/]);
    }
}

function delete_lead_forms_amocrm(){
    $post = $_POST;
    if(!$post or !$post['lead_id']){
        echo json_encode(['status' => 0, 'message' => 'Нет данных']);
        wp_die();
    }
    $post_obj = wp_delete_post($post['lead_id'], true);
    echo json_encode(['status' => ($post_obj ? 1 : 0)]);
    wp_die();
}
add_action( 'wp_ajax_delete_lead', 'delete_lead_forms_amocrm' );

function responsible_user_id_elementor_amocrm($form_id){
    $form_fields = get_post_meta( $form_id, 'elementor_forms-amocrm', 1 );
    if( !isset($form_fields['responsible_list']) ){
        return 0;
    }

    $distribution = (int)$form_fields['distribution'];
    $responsible_list = $form_fields['responsible_list'];
    $form_fields['current_responsible'] = isset($form_fields['current_responsible']) ? (int)$form_fields['current_responsible'] : 0;
    
    if($distribution){ // случайно
        $responsible_count = count($responsible_list) ? ( count($responsible_list) - 1) : 0;
        $form_fields['current_responsible'] = rand(0, $responsible_count);
    }else{
        $form_fields['current_responsible']++;
        $form_fields['current_responsible'] = isset($responsible_list[($form_fields['current_responsible'])]) ? ($form_fields['current_responsible']) : 0;
    }
    update_post_meta( $form_id, 'elementor_forms-amocrm', $form_fields );
    return (int)$responsible_list[($form_fields['current_responsible'])];
}


function testing_forms_amocrm(){
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_URL, 'https://devamo.ru/elementor/version');
    curl_setopt($curl, CURLOPT_HEADER, false);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query(['url' => $_SERVER['SERVER_NAME']]));
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
    $output = curl_exec($curl);
    curl_close($curl);
    $output = json_decode($output, true);
    return $output;
}

// Добавляет ссылку в админ бар сверху
add_action( 'admin_bar_menu', 'admin_bar_menu_forms_amocrm', 90 );
function admin_bar_menu_forms_amocrm( $wp_admin_bar ) {
	$wp_admin_bar->add_menu( array(
		'id'    => 'elementor_forms-amocrm',
		'title' => '<span class="ab-label">Интеграция форм Elementor с amoCRM</span>',
		'href'  => '/wp-admin/options-general.php?page=elementor_forms-amocrm',
	) );

}

// перевод
function elementorforms_amocrm_load_lang() {
    load_plugin_textdomain( 'elementor_forms-amocrm', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' ); 
}


add_action( 'elementor_pro/forms/new_record', function( $record, $handler ) {
    //make sure its our form
    $form_name = $record->get_form_settings( 'form_name' );
    $form_settings = $record->get('form_settings');
    $post_ID = $form_settings['form_post_id'];

    $raw_fields = $record->get( 'fields' );
    $fields = [];
    foreach ( $raw_fields as $id => $field ) {
        $fields[ $id ] = $field['value'];
    }

    $_POST = $fields;
    $_POST['post_ID'] = $post_ID;
    newForm_forms_amocrm();
}, 10, 2 );