<form action="/wp-admin/options-general.php?page=elementor_forms-amocrm" method="post">
    <input type="hidden" name="action" value="save_settings">
    <input type="hidden" name="nonce" value="<?php echo wp_create_nonce('elementor_forms-amocrm'); ?>">
    <div class="wrap">
        <h2 class="aci-title">
            <span>Общие настройки</span> 
            <a class="button button-order button-large" target="_blank" href="https://devamo.ru/elementor/payurl?url=<?php echo $_SERVER['SERVER_NAME'] ?>">Оплатить подписку</a>
            <a class="button button-auth button-large" target="_blank" href="https://devamo.ru/elementor/button">Авторизация в amoCRM</a>
            <a class="button button-red button-large" href="/wp-admin/options-general.php?page=elementor_forms-amocrm&clear=1">Обновить данные amoCRM</a>
            <a class="button button-default button-large" href="/wp-admin/options-general.php?page=elementor_forms-amocrm&logs">Отладка</a>
        </h2>

        <div class="card" style="max-width:100%">
            <h2 class="title">Мои формы</h2>
            <hr>
            <div class="row">
                <table class="wp-list-table widefat fixed striped table-view-list forms_amocrm">
                    <thead>
                        <tr>
                            <th scope="col" class="manage-column column-name column-primary desc">
                                <span>Название формы</span>
                            </th>
                            <th scope="col" id="shortcode" class="manage-column column-shortcode">Кол-во заявок</th>
                            <th scope="col" id="created" class="manage-column column-created desc">
                                <span>Создано</span>
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if($forms_custom){ ?>
                            <?php foreach($forms_custom as $form){ ?>
                            <tr>
                                <td class=" column-name has-row-actions column-primary">
                                    <a href="/wp-admin/options-general.php?page=elementor_forms-amocrm&elementor_forms_id=<?= $form['ID'] ?>" title="<?php _e( 'Edit form', 'elementor_forms-amocrm' ) ?>">
                                        <strong><?= $form['post_title'] ?></strong>
                                    </a>
                                </td>
                                <td class="shortcode column-shortcode"><?php echo getLeadsByForm_forms_amocrm($form['ID']); ?></td>
                                <td class="created column-created"><?= $form['post_date'] ?></td>
                            </tr>
                            <?php } ?>
                        <?php } ?>
                    </tbody>
                </table>
            </div>
        </div>

        <div class="card" style="max-width:100%">
            <h2 class="title">Все заявки</h2>
            <hr>
            <div class="row">
                <table class="wp-list-table widefat fixed striped table-view-list forms_amocrm leads_list">
                    <thead>
                        <tr>
                            <th scope="col" class="manage-column column-name column-primary desc">
                                <span>#</span>
                            </th>
                            <th scope="col" id="shortcode" class="manage-column column-shortcode">Форма</th>
                            <th scope="col" id="created" class="manage-column column-created desc">
                                <span>Создано</span>
                            </th>
                            <th scope="col" id="action" class="manage-column column-shortcode">Действие</th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if($leads){ ?>
                            <?php foreach($leads as $lead){ ?>
                            <tr>
                                <td class=" column-name has-row-actions column-primary">
                                    <a href="/wp-admin/options-general.php?page=elementor_forms-amocrm&lead_id=<?= $lead['ID'] ?>" title="Смотреть заявку">
                                        <strong>Заявка # <?= $lead['ID'] ?></strong>
                                    </a>
                                </td>
                                <td class="shortcode column-shortcode"><a href="/wp-admin/options-general.php?page=elementor_forms-amocrm&elementor_forms_id=<?= $lead['post_parent'] ?>"><?= get_the_title($lead['post_parent']) ?></a></td>
                                <td class="created column-created"><?= $lead['post_date'] ?></td>
                                <td class="action column-created"> <span data-lead="<?= $lead['ID'] ?>">Удалить</span></td>
                            </tr>
                            <?php } ?>
                        <?php } ?>
                    </tbody>
                </table>
            </div>
        </div>

        <div class="card" style="max-width:100%">
            <div class="timezone">
                <div class="row">
                    <div class="name">Часовой пояс</div>
                    <div class="value">
                        <select id="time_zone" name="elementor_forms-amocrm[time_zone]">
                            <option value="0">Не выбрано</option>
                            <?php if($time_zones){ ?>
                            <?php foreach($time_zones as $time_zone_name => $time_zone_value){ ?>
                            <option value="<?php echo $time_zone_value ?>" <?php echo $time_zone_value === $settings['time_zone'] ? 'selected' : '' ?>><?php echo $time_zone_name ?></option>
                            <?php } ?>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="value"></div>
                </div>
            </div>

            <div class="">
                <div class="row">
                    <div class="name">Исключить страницы</div>
                    <div class="value">
                        <textarea name="elementor_forms-amocrm[urls_disabled]" id="" cols="30" rows="10" placeholder="Укажите ID страниц через запятую, на которых не нужно собирать данные из форм"><?php echo $settings['urls_disabled'] ?></textarea>
                    </div>
                    <div class="value"></div>
                </div>
            </div>

		</div>
        <br>
        <button type="submit" class="button button-primary button-large">Сохранить настройки</button>

    </div>
</form>
<script>
    var pipelines = 0;
    var pipeline_id = 0;
    var pipeline_status = 0;
    var confirm_lang = 'Вы уверены?';
</script>

